package cz.cvut.felk.atg.azui;

import java.util.HashMap;
import java.util.LinkedList;

public class Sem02 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		HashMap<Integer, ChessNode> nodes = new HashMap<Integer, ChessNode>();
		HashMap<Integer, Edge> edges = new HashMap<Integer, Edge>();
		
		final int CHB_SIZE = 5;
		
		for (int i=1; i<=CHB_SIZE; i++) 
			for (int j=1; j<=CHB_SIZE; j++)	{
				nodes.put(i*10+j, new ChessNode(i*10+j));				
			}
		
		
		for (int i=1; i<=CHB_SIZE; i++) 
			for (int j=1; j<=CHB_SIZE; j++)	{
				if (i>2) {
					if (j>1) edges.put(i*100+j*10+1, new Edge(i*100+j*10+1, nodes.get(i*10+j), nodes.get((i-2)*10+(j-1))));
					if (j<CHB_SIZE) edges.put(i*100+j*10+2, new Edge(i*100+j*10+2, nodes.get(i*10+j), nodes.get((i-2)*10+(j+1))));
				}
				if (i<(CHB_SIZE-1)) {
					if (j>1) edges.put(i*100+j*10+3, new Edge(i*100+j*10+3, nodes.get(i*10+j), nodes.get((i+2)*10+(j-1))));
					if (j<CHB_SIZE) edges.put(i*100+j*10+4, new Edge(i*100+j*10+4, nodes.get(i*10+j), nodes.get((i+2)*10+(j+1))));
				}
				if (i>1) {
					if (j>2) edges.put(i*100+j*10+5, new Edge(i*100+j*10+5, nodes.get(i*10+j), nodes.get((i-1)*10+(j-2))));
					if (j<(CHB_SIZE-1)) edges.put(i*100+j*10+6, new Edge(i*100+j*10+6, nodes.get(i*10+j), nodes.get((i-1)*10+(j+2))));
				}
				if (i<CHB_SIZE) {
					if (j>2) edges.put(i*100+j*10+7, new Edge(i*100+j*10+7, nodes.get(i*10+j), nodes.get((i+1)*10+(j-2))));
					if (j<(CHB_SIZE-1)) edges.put(i*100+j*10+8, new Edge(i*100+j*10+8, nodes.get(i*10+j), nodes.get((i+1)*10+(j+2))));
				}
			}
		
//		System.out.println(nodes);
		DFS p = new DFS();
		LinkedList<Node> l = new LinkedList<Node>();
		l.add(nodes.get(11));
		p.findPathDFS(nodes.get(11), l, CHB_SIZE*CHB_SIZE);
		System.out.println(p.getPath());
	}
	
	

}
