package cz.cvut.felk.atg.azui;

import java.util.ArrayList;
import java.util.LinkedList;

public class DFS {
	
	private String path = "no"; 
		
		
	
	public void findPathDFS(ChessNode node, LinkedList<Node> path, int depth) {
		if (depth == 1) {
			this.path = path.toString();
			return;
		}
		node.setVisited(true);
		for (Edge e:node.getOutgoingEdges()) {
			ChessNode toNode = (ChessNode)e.getToNode();
			if (toNode.isVisited()) {
				continue;
			}
			path.addLast(toNode);
			findPathDFS(toNode, path, depth-1);			
			path.removeLast();
			toNode.setVisited(false);
		}
	}

	public String getPath() {
		return path;
	}
}
